
#include"KStringHolder.h"


KStringHolder::KStringHolder()
{
	refCount=0;
	a_text=0;
	w_text=0;
	count=0;
	InitializeCriticalSection(&cs_a_text);
}

KStringHolder::~KStringHolder()
{
	DeleteCriticalSection(&cs_a_text);
}

void KStringHolder::AddReference()
{
	InterlockedIncrement(&refCount);
}

void KStringHolder::ReleaseReference()
{
	LONG res=InterlockedDecrement(&refCount);
	if(res==0)
	{
		if(a_text)
		{
			free(a_text);
		}
		if(w_text)
		{
			free(w_text);
		}
		delete this;
	}
}

const char* KStringHolder::GetAnsiVersion()
{
	EnterCriticalSection(&cs_a_text);

	if(a_text)
	{
		LeaveCriticalSection(&cs_a_text);
		return a_text;
	}else
	{
		int length = WideCharToMultiByte(CP_ACP,0, w_text, -1, 0,0,0,0);
		if (length)
		{
			a_text = (char*)malloc(length);
			if (WideCharToMultiByte(CP_ACP,0, w_text, -1, a_text,length,0,0))
			{
				LeaveCriticalSection(&cs_a_text);
				return a_text;
			}
			free(a_text);
			a_text=0;
		}

		LeaveCriticalSection(&cs_a_text);
		return 0; // conversion error
	}
}